﻿using System;
using EmployeeManagement;
using System.Diagnostics;
using Codeer.Friendly;
using Codeer.Friendly.Windows;
using System.IO;

namespace EmployeeManagementAPI
{
    public class EmployeeManagementApp : IDisposable
    {
        //開始
        public static EmployeeManagementApp Start()
        {
#if DEBUG
            string path = Path.GetFullPath("../../../bin/Debug/EmployeeManagement.exe");
#else
            string path = Path.GetFullPath("../../../bin/Release/EmployeeManagement.exe");
#endif
            return new EmployeeManagementApp(Process.Start(path));
        }

        WindowsAppFriend app;
        AppVar managementSystem;

        //コンストラクタ
        EmployeeManagementApp(Process process)
        {
            app = new WindowsAppFriend(process, "4.0");
            IntPtr handle = Process.GetProcessById(process.Id).MainWindowHandle;
            AppVar mainForm = app["System.Windows.Forms.Control.FromHandle"](handle);
            managementSystem = mainForm["system"]();
        }

        //終了
        public void Dispose()
        {
            Process process = Process.GetProcessById(app.ProcessId);
            app.Dispose();
            process.CloseMainWindow();
        }

        //登録
        public bool Add(string name, string age, string post)
        {
            return (bool)managementSystem["Add"](name, age, post).Core;
        }

        //検索
        public EmployeeData Find(string name)
        {
            return (EmployeeData)managementSystem["Find"](name).Core;
        }
    }
}
