﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using EmployeeManagementAPI;
using EmployeeManagement;

namespace TestProject
{
    [TestClass]
    public class AcceptanceTest
    {
        [TestMethod]
        public void Test()
        {
            //アプリの起動。スコープを抜けるときアプリ終了。
            using (EmployeeManagementApp app = EmployeeManagementApp.Start())
            {
                //登録。
                Assert.IsTrue(app.Add("山田太郎", "28", "係長"));

                //年齢は数値のみ入力可能。
                Assert.IsFalse(app.Add("鈴木次郎", "32才", "部長"));

                //同一名称の登録は許容しない仕様。
                Assert.IsFalse(app.Add("山田太郎", "30才", "次長"));

                //検索 ヒットしない
                EmployeeData findSuzuki = app.Find("鈴木次郎");
                Assert.IsNull(findSuzuki);

                //検索 ヒット
                EmployeeData findYamada = app.Find("山田太郎");
                Assert.AreEqual("山田太郎", findYamada.Name);
                Assert.AreEqual(28, findYamada.Age);
                Assert.AreEqual("係長", findYamada.Post);
            }
        }
    }
}
